;JINJ - JONHIE IS NOT JONES

        INCLUDE "DATMENU.ASM"
	ORG 32768
        CALL LICHAR          ;RUTINA DE LETRAS PROPIAS LETRAS.ASM
 ;IMPRESION DEL LOGO CEZ GS
        XOR A
        OUT (254),A
        CALL RUBORCO
        LD DE,CEZLOGO
        LD A,3
        LD (ALT),A
        LD A,11
        LD (ANCHO),A
        DEC A
        LD B,A             ;FILA
        LD (FIL_DAT),A
        ADD A,2
        LD C,A             ;COLUMNA
        LD (COL_DAT),A
        CALL IM_CHAR
        CALL IMPRMAR       ;FIN DE IMPRESION DEL MARCADOR DE LA DERECHA
LOGUAI  XOR A
        IN A,(#FE)
        CPL
        AND #1F
        JR Z,LOGUAI
;FIN IMPRESION DEL LOGO DE CEZ GS

        JP MENU
DESMENU
        LD A,6
        LD (VIDAS),A
;Datos de los objetos.
        LD A,39
        LD (60639),A
        LD A,58
        LD (59246),A
        LD A,36
        LD (60078),A
        LD A,40
        LD (62118),A
;Datos de las posiciones de los obstaculos
        LD A,15
        LD (58736),A
        LD (59040),A
        LD A,13
        LD (58537),A
;Vaciar la variable de control
        XOR A
        LD (CONTROL),A
        LD (CONVID),A
;Inicio de tabla de pantallas
        LD A,63             ;VALOR INICIAL PARA EL JUEGO 63
        LD (PANTA),A
        LD (LAST_SE),A
        LD A,2              ;VALOR INICIAL PARA EL JUEGO 2
        LD (SENPRO),A
        LD A,4              ;valor en el juego = 4
        LD (OBJE),A

        CALL INVALOP        ;QUE CONTROL VAS A UTILIZAR?
        LD A,(CONTROL)
        CP 3
        JP Z,MENU
        CALL COMIENZO       ;llamada a rutinas de impresion
        CALL RUBOR          ;borrado de pantalla
        CALL MAPPING        ;llamada a rutina de mapeado
        CALL BUPAIM         ;busqueda de pantalla a imprimir
        CALL RU_TENE        ;llamada a rutina de Tabla de enemigos x pantalla


;INICIALIZACION DE VARIABLES DE LA POSIC.DEL SPRITE
        LD A,2               ;VALOR PARA EL JUEGO FILA 2
        LD (FILA),A
        LD (LAST_P+1),A
        LD A,2               ;VALOR PARA EL JUEGO COLUMNA 2             ESTE SOBRA
        LD (COLU),A
        LD (LAST_P),A
        LD HL,JU_DER         ;guardamos las direcciones iniciales
        LD (POS_D),HL        ;de cada movimiento del prota.
        LD HL,JU_IZQ
        LD (POS_I),HL
        LD HL,JU_ARR
        LD (POS_A),HL
        LD HL,JU_ABA
        LD (POS_B),HL
;FIN INIC.DE VARIABLES
        LD A,2                                                          ;ESTE TAMBIEN SOBRA
        LD (ANCHO),A
        LD (ALT),A
        LD A,(POS_D)        ;TRANSFERIR LOS DATOS EN POS_D A DE
        LD E,A
        LD A,(POS_D+1)
        LD D,A
LLAMADA CALL MOV
        LD (POS_D),DE       ;GUARDAR EL FRAME


;######################
; RUTINA DE CONTROL
;######################

TECLAS

        LD A,(DEAD)
        CP 1
        JP Z,FIN
        LD A,(FLAGPA)
        CP 1
        JR NZ,CONT_

        LD A,(SENPRO)      ;LE METO EL VALOR DE SENPRO EN ESTA VARIABLE PARA QUE ME LA
        LD (LAST_SE),A     ;GUARDE Y RESTAURARLA CUANDO TE MATEN.

        CALL RUBOR
        CALL MAPPING
        CALL BUPAIM
        CALL RU_TENE
        LD A,(POS_PRO)     ;TRASPASO ULTIMO FRAME CONOCIDO DEL PROTA AL PASAR AHORA DE PANTALLA.
        LD E,A
        LD A,(POS_PRO+1)
        LD D,A
        CALL MOV
CONT_
        LD A,(CONTROL)
        CP 0               ; SI HAY 0 EL CONTROL ES CON EL TECLADO
        JR Z,MT

;####################
; RUTINA DE JOYSTICK
;####################


       LD E,0
       LD A,231          ;SINCLAIR JOYSTICK O LO QUE ES LO MISMO
       IN A,(#FE)        ;TECLAS DEL 6 AL 0
       PUSH AF
       XOR 31            ;ENMASCARAMOS LAS TECLAS DEL 6 AL 9
       RRA               ;DISCRIMINAMOS EL BIT 0
       RRA
       RL E              ;PASAMOS ARRIBA
       RRA
       RL E              ;PASAMOS ABAJO
       LD D,E            ;GUARDO LOS DATOS
       POP AF
       XOR 31
       RRA
       RRA
       RRA               ;DISCRIMINAMOS MOV.VERTICAL
       RRA
       RL E              ;METO MOV.DERECHA
       RRA
       RL E              ;METO MOV.IZQ
       SLA E
       SLA E             ;LAS DEJO EN SU SITIO
       LD A,D            ;CARGO D PARA SUMAR A E
       OR E
       LD E,A
       JR DECONT
;########################
; FIN RUTINA DE JOYSTICK
;########################



;###################
; RUTINA DE TECLADO
;###################

MT
       LD E,0
       LD A,#DF
       IN A,(#FE)
       XOR 3            ;ENMASCARAMOS LAS TECLAS O y P
       RRA
       RL E
       RRA
       RL E
       LD A,#FB
       IN A,(#FE)
       XOR 1
       RRA
       RL E
       LD A,#FD
       IN A,(#FE)
       XOR 1
       RRA
       RL E             ;en E tenemos el valor de las pulsaciones de p,o,q,a
;#######################
; FIN RUTINA DE TECLADO
;#######################

DECONT
        LD A,E          ;comprobaciones de doble pulsacin de tecla
        AND 3           ;que har que se diriga o no a un lugar concreto.
        CP 3
        JR NZ,CD1
        CALL ARRI       ;si pulsadas q y a entonces sube arriba
        JP AFINTEC
CD1     LD A,E
        AND 12
        CP 12           ;si pulsadas p y o entonces ve a la derecha
        JR NZ,CD2
        CALL DERE
        JP AFINTEC
CD2     LD A,E
        AND 15
        CP 5            ;si pulsadas o y a entonces ve a izquierda
        JR NZ,CD3
        CALL IZQ
        JP AFINTEC
CD3     LD A,E
        AND 15
        CP 6            ;si pulsadas o y q ve a izquierda
        JR NZ,CD4
        CALL IZQ
        JP AFINTEC
CD4     LD A,E
        AND 15
        CP 9            ;si pulsadas p y a ve a derecha
        JR NZ,CD5
        CALL DERE
        JP AFINTEC
CD5     LD A,E
        AND 15
        CP 10           ;si pulsadas p y q ve a derecha
        JR NZ,CD6
        CALL DERE
        JP AFINTEC
CD6                    ;fin comprobaciones de doble pulsacion de tecla
        AND A
        SRA E
        PUSH AF
        PUSH DE
        CALL C,ABA
        POP DE
        POP AF
        SRA E
        PUSH AF
        PUSH DE
        CALL C,ARRI
        POP DE
        POP AF
        SRA E
        PUSH AF
        PUSH DE
        CALL C,IZQ
        POP DE
        POP AF
        SRA E
        PUSH AF
        PUSH DE
        CALL C,DERE
        POP DE
        POP AF
AFINTEC
        CALL ININE     ;LLAMADA A RUTINA DE GESTION DE ENEMIGOS POR PANTALLA
FINTEC
        LD A,(OBJE)
        CP 4
        JP C,JOGO
DLJOG   HALT

        JP TECLAS
;#######################
; FIN RUTINA DE CONTROL
;#######################


;#####################################
; RUTINA DE DIRECCIONES DE MOVIMIENTO
;#####################################
;                                            MOVIMIENTO CARACTER A CARACTER.
;                                            ===============================
DERE    LD A,(COLU)
        CP 22                ;MAX.POSIC.PANTALLA A DERECHA
        JR NZ,YSIDE
        LD A,1
        LD (SENPRO),A
        LD (FLAGPA),A        ; BANDERIN PARA SABER QUE VAMOS A PASAR DE PANTALLA
        XOR A                ;AHORA DEBO PONER EL MONIGOTE EN SU COLUMNA CORRESPONDIENTE
        LD (COLU),A
        LD (LAST_P),A        ;ESTAS LINEAS SON PARA INICIALIZAR LOS VALORES CUANDO MUERES
        LD A,(FILA)          ;
        LD (LAST_P+1),A      ;
        LD A,(POS_D)
        LD (POS_PRO),A
        LD A,(POS_D+1)
        LD (POS_PRO+1),A

        RET
YSIDE   ADD A,2
        LD (COLU),A
                             ;       COMPROBACION DE CHOQUES
        CALL IMP_AT     ;NUEVO VAL ATTR DE HL PARA COMPROBAR LA POSIC.JUSTA (SPRITE 2X2)
        LD A,(HL)
        CP 0
        JR NZ,NODE
        LD A,(FILA)    ;VER SIGUIENTE FILA SI TAMPOCO CHOCA
        INC A
        LD (FILA),A
        CALL IMP_AT
        LD A,(HL)
        CP 0
        JR Z,SI_DE
        LD A,(FILA)
        DEC A
        LD (FILA),A
NODE    LD A,(COLU)
        SUB 2
        LD (COLU),A
        RET
SI_DE   LD A,(FILA)
        DEC A
        LD (FILA),A
        XOR A
        LD (DIR_SP),A   ;BANDERIN DE MOVIMIENTO A DERECHA LEVANTADO
        LD A,(COLU)
        SUB 2
        LD (COLU),A
        CALL BORRADO ;SOLO LA PRIMERA COLUMNA DEL SPRITE
        LD A,(COLU)
        ADD A,1
        LD (COLU),A
        LD A,(POS_D)  ;TRANSFERIR LOS DATOS EN POS_D A DE
        LD E,A
        LD (POS_PRO),A
        LD A,(POS_D+1)
        LD D,A
        LD (POS_PRO+1),A
        CALL MOV
        LD A,(DE)
        CP 128
        JR NZ,MY
        LD DE,JU_DER
        LD (POS_D),DE
        RET
MY      LD (POS_D),DE
        RET

IZQ     LD A,(COLU)
        CP 0
        JR NZ,YSIZ
        LD A,3
        LD (SENPRO),A
        LD A,1
        LD (FLAGPA),A        ; BANDERIN PARA SABER QUE VAMOS A PASAR DE PANTALLA
        LD A,22              ;CAMBIO LA POSICION DEL PROTA
        LD (COLU),A
        LD (LAST_P),A        ;INICIALIZAR VALORES AL MORIR
        LD A,(FILA)          ;
        LD (LAST_P+1),A      ;

        LD A,(POS_I)
        LD (POS_PRO),A
        LD A,(POS_I+1)
        LD (POS_PRO+1),A
        RET
YSIZ    DEC A
        LD (COLU),A
                            ;DETECCION DE CHOQUE
        CALL IMP_AT
        LD A,(HL)
        CP 0
        JR NZ,NOIZ
        LD A,(FILA)          ;VER SIGUIENTE FILA , SI NO TOCA
        INC A
        LD (FILA),A
        CALL IMP_AT
        LD A,(HL)
        CP 0
        JR Z,SI_IZ
        LD A,(FILA)
        DEC A
        LD (FILA),A
NOIZ    LD A,(COLU)
        INC A
        LD (COLU),A
        RET
SI_IZ   LD A,(FILA)
        DEC A
        LD (FILA),A
        LD A,(COLU)
        INC A
        LD (COLU),A
        LD A,1
        LD (DIR_SP),A
        CALL BORRADO
        LD A,(COLU)
        DEC A
        LD (COLU),A
        LD C,A
        LD A,(FILA)
        LD B,A
        CALL IM_CHAR
        LD (50000),HL
        LD A,(POS_I)         ;TRANSFERIR LOS DATOS EN POS_I A DE
        LD E,A
        LD (POS_PRO),A
        LD A,(POS_I+1)
        LD D,A
        LD (POS_PRO+1),A
        CALL MOV
        LD A,(DE)
        CP 128
        JR NZ,MYI
        LD DE,JU_IZQ
        LD (POS_I),DE
        RET
MYI     LD (POS_I),DE
        RET

ARRI    LD A,(FILA)
        CP 0
        JR NZ,YSIA
        XOR A
        LD (SENPRO),A
        LD A,1
        LD (FLAGPA),A        ; BANDERIN PARA SABER QUE VAMOS A PASAR DE PANTALLA
        LD A,16              ;CAMBIO LA POSICION DEL PROTA
        LD (FILA),A
        LD (LAST_P+1),A       ;INICIALIZAR VALORES AL MORIR
        LD A,(COLU)           ;
        LD (LAST_P),A         ;
        LD A,(POS_A)
        LD (POS_PRO),A
        LD A,(POS_A+1)
        LD (POS_PRO+1),A
        RET
YSIA    DEC A
        LD (FILA),A
                              ;DETECCION DE CHOQUE
        CALL IMP_AT
        LD A,(HL)
        CP 0
        JR NZ,NO_AR           ;SI HAY OBSTACULO SALTA
        LD A,(COLU)           ;COMPRUEBO LA OTRA POSICION
        INC A
        LD (COLU),A
        CALL IMP_AT
        LD A,(HL)
        CP 0
        JR Z,SI_AR
        LD A,(COLU)
        DEC A
        LD (COLU),A
NO_AR   CP 77                 ;MIRA A VER SI ES UNO DE LOS OBJETOS A RECOJER
        JR NZ,SINOAR
        CALL RU_OBJE          ;SALTA A LA RUTINA DE GESTION DE OBJETOS
SINOAR  LD A,(FILA)
        INC A
        LD (FILA),A
        RET
SI_AR   LD A,(COLU)
        DEC A
        LD (COLU),A
        LD A,2
        LD (DIR_SP),A      ;EL VALOR DEL A.PANTALLA AQUI EST EN 50000
        CALL BORRADO       ;Y NO SE HA CAMBIADO. CUANDO VUELVE DEL CALL, SI QUE LO HA HECHO
        LD A,(POS_A)       ;TRANSFERIR LOS DATOS EN POS_A A DE
        LD E,A
        LD (POS_PRO),A
        LD A,(POS_A+1)
        LD D,A
        LD (POS_PRO+1),A
        CALL MOV
        LD A,(DE)
        CP 128
        JR NZ,MYA
        LD DE,JU_ARR
        LD (POS_A),DE
        RET
MYA     LD (POS_A),DE
        RET

ABA     LD A,(FILA)
        CP 16              ;MAX.POSIC.PANT. HACIA ABAJO
        JR NZ,YSIB
        LD A,2
        LD (SENPRO),A
        LD A,1
        LD (FLAGPA),A      ; BANDERIN PARA SABER QUE VAMOS A PASAR DE PANTALLA
        XOR A              ;CAMBIO LA POSICION DEL PROTA
        LD (FILA),A
        LD (LAST_P+1),A    ;INICIALIZAR VALORES AL MORIR
        LD A,(COLU)        ;
        LD (LAST_P),A      ;
        LD A,(POS_B)
        LD (POS_PRO),A
        LD A,(POS_B+1)
        LD (POS_PRO+1),A
        RET
YSIB    ADD A,2
        LD (FILA),A
                           ;       COMPROBACION DE CHOQUES
        CALL IMP_AT     ;NUEVO VAL ATTR DE HL PARA COMPROBAR LA POSIC.JUSTA (SPRITE 2X2)
        LD A,(HL)
        CP 0
        JR NZ,NOAB
        LD A,(COLU)   ;COMPRUEBO LA OTRA POSICION
        INC A
        LD (COLU),A
        CALL IMP_AT
        LD A,(HL)
        CP 0
        JR Z,SI_AB

        LD A,(COLU)
        DEC A
        LD (COLU),A
NOAB    LD A,(FILA)
        SUB 2
        LD (FILA),A
        RET
SI_AB   LD A,(COLU)
        DEC A
        LD (COLU),A
        LD A,3
        LD (DIR_SP),A            ;BANDERIN DE MOVIMIENTO A DERECHA LEVANTADO
        LD A,(FILA)
        SUB 2
        LD (FILA),A
        CALL BORRADO             ;SOLO LA PRIMERA FILA DEL SPRITE
        LD A,(FILA)
        ADD A,1
        LD (FILA),A
        LD A,(POS_B)             ;TRANSFERIR LOS DATOS EN POS_B A DE
        LD E,A
        LD (POS_PRO),A
        LD A,(POS_B+1)
        LD D,A
        LD (POS_PRO+1),A
        CALL MOV
        LD A,(DE)
        CP 128
        JR NZ,MYB
        LD DE,JU_ABA
        LD (POS_B),DE
        RET
MYB     LD (POS_B),DE
        RET


;######################################
; RUTINA DE MUERTE Y PASO DE PANTALLA
;######################################


FIN     XOR A
        LD (DEAD),A

;SONIDO MUERTE
        PUSH BC
        LD B,3
ARMU    PUSH BC
	LD C,175
SONMU   OUT (254),A
        LD B,C
ESPERA  DJNZ ESPERA
        XOR 16
        DEC C
        JR NZ,SONMU
        POP BC
        DJNZ ARMU
        POP BC
;FIN SONIDO MUERTE
        CALL BVIDAS
        LD A,(VIDAS)
        DEC A
        LD (VIDAS),A
        CP 0
        JP Z,SONMUERTE
        LD A,(LAST_SE)
        LD (PANTA),A
        CALL RUBOR
        CALL MAPPING
        CALL BUPAIM
        CALL RU_TENE
        LD A,(POS_PRO)         ;TRASPASO ULTIMO FRAME CONOCIDO DEL PROTA AL PASAR AHORA DE PANTALLA.
        LD E,A
        LD A,(POS_PRO+1)
        LD D,A
        LD A,(LAST_P)
        LD (COLU),A
        LD A,(LAST_P+1)
        LD (FILA),A
        CALL MOV
        JP MT


;#######################################################
;COMIENZO SUBRUTINA DE IMPRESION DE MARCADOR Y PANTALLA
;#######################################################



COMIENZO      LD DE,MA_REJ       ;IMPRESION DEL MARCADOR DE LA DERECHA
              LD A,18
              LD (ALT),A
              LD A,8
              LD (ANCHO),A
              XOR A
              LD B,A             ;FILA
              LD (FIL_DAT),A
              LD A,24
              LD C,A             ;COLUMNA
              LD (COL_DAT),A
              CALL IM_CHAR
              CALL IMPRMAR       ;FIN DE IMPRESION DEL MARCADOR DE LA DERECHA
              LD DE,MA_BAJ       ;IMPRESION DEL MARCADOR DE abajo
              LD A,6
              LD (ALT),A
              LD A,32
              LD (ANCHO),A
              LD A,18
              LD B,A             ;FILA
              LD (FIL_DAT),A
              XOR A
              LD C,A             ;COLUMNA
              LD (COL_DAT),A
              CALL IM_CHAR
              CALL IMPRMAR       ;FIN DE IMPRESION DEL MARCADOR DE abajo
              RET                ;DEVOLVEMOS EL CONTROL AL JUEGO EN EL COMIENZO DEL MISMO.


PANT_FIN      PUSH AF
              PUSH BC
              PUSH DE
              PUSH HL
              LD DE,PLA_FINAL       ;IMPRESION DEL FINAL DEL JUEGO
              LD A,10
              LD (ALT),A
              LD (ANCHO),A
              LD A,7
              LD B,A      ;FILA
              LD (FIL_DAT),A
              LD A,11
              LD C,A      ;COLUMNA
              LD (COL_DAT),A
              CALL IM_CHAR
              CALL IMPRMAR       ;FIN DE IMPRESION DEL FINAL DEL JUEGO
              CALL ESCRIBE
              POP HL
              POP DE
              POP BC
              POP AF
              RET                ;DEVOLVEMOS EL CONTROL AL JUEGO EN EL COMIENZO DEL MISMO.



;###############################
; BUSQUEDA DE PANTALLA E IMPRESION DE DATOS
;###############################


BUPAIM        PUSH DE         ;GUARDO DE
              LD A,(PANTA)
              LD HL,TADAPAN   ;DATOS DE LAS DIRECCIONES DONDE ESTAN LAS PANTALLAS.
              ADD A,A
              ADD A,L
              LD L,A
              LD A,(HL)
              LD E,A
              INC HL
              LD A,(HL)
              LD D,A
              PUSH DE         ;TRASPASO EL VALOR DE A HL
              POP HL
              POP DE          ;SACO EL VALOR DE
              LD A,(HL)       ;LOS DATOS DE CADA PANTALLA LOS SACAMOS
              LD (PANTA),A
              INC HL
A_FRM         LD A,(HL)
              CP 128
              RET Z
              LD (DIRDMA),A           ;LO GUARDAMOS
              CALL PUNTERO
              INC HL
              LD A,(HL)
              LD B,A           ;FILA A IMPRIMIRLO
              LD (FIL_DAT),A
              INC HL                 ;EN VEZ DE GUARDARLOS EN 60001 60002 SI SUPIERAS
              LD A,(HL)              ;DE ANTEMANO QUE GRAFICO HAY QUE IMPRIMIR PUEDES GUARDAR ESTO YA EN BC
              LD C,A           ;COLUMNA A IMPRIMIRLO
              LD (COL_DAT),A
              PUSH HL
              CALL IM_CHAR
              CALL IMPRMAR
              POP HL
              INC HL
              JR A_FRM

;####################################
; SUBRUTINA DE BUSQUEDA DE LOS DATOS
;####################################

PUNTERO       LD DE,TABDATA
AHIBA         LD A,(DIRDMA)
              LD B,A
NEWCOMP       LD A,(DE)
              CP B
              JR Z,ENCONTRADO
              PUSH HL
              LD HL,39
METRO         ADD HL,DE
              PUSH HL
              POP DE
              POP HL
              JR NEWCOMP
ENCONTRADO    INC DE
              LD A,(DE) ;ALTO
              LD (ALT),A
              INC DE
              LD A,(DE) ;ANCHO
              LD (ANCHO),A
              INC DE
; A ESTA ALTURA YA TENEMOS EN DE LOS DATOS DEL DIBUJO A IMPRIMIR
              RET


IMPRMAR        LD A,(ALT)
               LD B,A       ;ALTURA
I_ARRIBA       PUSH BC
               LD B,8
I_BUC          PUSH BC      ;GUARDAMOS LOS 8 SCANNES
               PUSH HL
               LD A,(ANCHO)
               LD B,A
I_BU           LD A,(DE)
               LD (HL),A
               INC DE
               INC L
               DJNZ I_BU
               POP HL
               LD A,H          ;CARGO LA PRIMERA POSIC.CALCULADA DEL A.PANT.
               AND 7
               CP 7
               JR NZ,I_SAL1      ;ES FIN DE CARACTER?
               LD A,L
               AND %11100000   ;ES LA ULTIMA FILA DEL TERCIO?
               CP 224
               JR Z,I_SIGTER
               LD A,#20
               ADD A,L
               LD L,A
               JR I_ALTO
I_SIGTER       LD A,L          ;LA L DEBE SER 0 EN SUS 3 BITS SUP.
               AND %00011111
               LD L,A
               LD A,H
               AND 24
               CP 8
               JR Z,I_TERTRES
               JR C,I_TERDOS
I_TERUNO       LD H,#40
               JR I_SAL2
I_ALTO         LD A,H
               AND 24
               CP 8
               JR Z,I_TERDOS     ;ESTOY EN TERCIO 2
               JR C,I_TERUNO     ;ESTOY EN TERCIO 1
I_TERTRES      LD H,#50
               JR I_SAL2
I_TERDOS       LD H,#48
               JR I_SAL2
I_SAL1         INC H
I_SAL2         POP BC          ;SACAMOS 8 SCANNES
               DJNZ I_BUC
               POP BC          ;SACAMOS LA ALTURA
               DJNZ I_ARRIBA
               PUSH DE         ;GUARDAMOS EL CODIGO DEL COLOR
               CALL IM_ATD_
               POP DE
I_AT_NOR       LD A,(ALT)
               LD B,A           ;EL ALTO DEL SPRITE
I_ATB          PUSH BC          ;GUARDAMOS EL ALTO
               PUSH HL          ;LA POSICION DE HL EN A.ATTR
               LD A,(ANCHO)
               LD B,A
I_ATB1         LD A,(DE)
               LD (HL),A
               INC DE
               INC L
               DJNZ I_ATB1
               POP HL          ;SACAMOS LA POSICION ATTR
               LD A,#20
               LD C,A
               ADC HL,BC
               POP BC          ;SACAMOS EL ALTO DEL SPRITE
               DJNZ I_ATB
               RET

;FIN IMPRESION DE MARCADOR Y PANTALLA
;#####################################



;#####################
;IMPRESION DE SPRITE

MOV     LD A,(FILA)
        LD B,A
        LD A,(COLU)
        LD C,A
;IMPRIMO PRIMERO LOS ATRIBUTOS PARA QUE NO ME HAGA EL EFECTO FEO

        PUSH DE         ;GUARDAMOS LA POS.ACTUAL DEL SPRITE
        CALL IMP_AT
        LD DE,AT_JUL
AT_NOR  LD B,2   ;EL ALTO DEL SPRITE
ATB     PUSH BC          ;GUARDAMOS EL ALTO
        PUSH HL          ;LA POSICION DE ATTR EN HL
        LD A,(ANCHO)
        LD B,A
ATB1    LD A,(DE)
        LD (HL),A
        INC DE
        INC L
        DJNZ ATB1
        POP HL          ;SACAMOS LA POSICION ATTR
        LD A,#20
        LD C,A
        ADC HL,BC
        POP BC          ;SACAMOS EL ALTO DEL SPRITE
        DJNZ ATB
        POP DE          ;SACAMOS EL VAL.DE=SPRITE
;AHORA SE IMPRIME EL SPRITE

        LD A,(FILA)
        LD B,A
        LD A,(COLU)
        LD C,A
        CALL IM_CHAR       ;SALIDA HL POSIC.ARCH.PANTALLA
        LD (50000),HL
        PUSH HL
        LD A,(ALT)
        LD B,A       ;ALTURA
ARRIBA  PUSH BC
        LD B,8
BUC     PUSH BC      ;GUARDAMOS LOS 8 SCANNES
        PUSH HL
        LD A,(ANCHO)
        LD B,A
BU      LD A,(DE)
        LD (HL),A
        INC DE
        INC L
        DJNZ BU
        POP HL
        LD A,H          ;CARGO LA PRIMERA POSIC.CALCULADA DEL A.PANT.
        AND 7
        CP 7
        JR NZ,SAL1      ;ES FIN DE CARACTER?
        LD A,L
        AND %11100000   ;ES LA ULTIMA FILA DEL TERCIO?
        CP 224
        JR Z,SIGTER
        LD A,#20
        ADD A,L
        LD L,A
        JR ALTO
SIGTER  LD A,L          ;LA L DEBE SER 0 EN SUS 3 BITS SUP.
        AND %00011111
        LD L,A
        LD A,H
        AND 24
        CP 8
        JR Z,TERTRES
        JR C,TERDOS
TERUNO  LD H,#40
        JR SAL2
ALTO    LD A,H
        AND 24
        CP 8
        JR Z,TERDOS     ;ESTOY EN TERCIO 2
        JR C,TERUNO     ;ESTOY EN TERCIO 1
TERTRES LD H,#50
        JR SAL2
TERDOS  LD H,#48
        JR SAL2
SAL1    INC H
SAL2    POP BC          ;SACAMOS 8 SCANNES
        DJNZ BUC
        POP BC          ;SACAMOS LA ALTURA
        DJNZ ARRIBA
        POP HL          ;SACO LA DIR A.PANT GUARDADA
        CALL PASOS
        RET

;FIN RUTINA IMPRESION

FILA    EQU   51800
COLU    EQU   51802
ALT     EQU   51804
ANCHO   EQU   51806
POS_D   EQU   51808
POS_I   EQU   51810
POS_A   EQU   51812
POS_B   EQU   51814
DIR_SP  EQU   51816
FIL_DAT EQU   51818
COL_DAT EQU   51820
DIRDMA  EQU   51822
FLAGPA  EQU   51824
PANTA   EQU   51826
POS_PRO EQU   51924     ;SIRVE PARA GUARDAR LA ULTIMA POSICION DEL PROTA QUE HAY EN CUALQUIER POS_XX A
                        ;LA HORA DE PASAR DE PANTALLA. Y SABER QUE FRAME IMPRIMIR.
DIRENM  EQU   51926
OBJE    EQU   51928
NOOBJE  EQU   51930     ;SIRVE PARA DEV.CONTROL CUANDO UN OBJETO YA HA SIDO UTILIZADO
TXT     EQU   51932
LAST_P  EQU   51946     ;GUARDA LA FILA Y LA COLU DEL PROTA AL PASAR DE PANTALLA (COLU Y FILA)
LAST_SE EQU   51948     ;VALOR DE PANTA A TRANSF.CUANDO TE MATAN
PPTAB   EQU   51950     ;TABLA DE DIRECCIONES EN PANTALLA DONDE IMPRIMIR EL FINAL DEL JUEGO
PPDAT   EQU   51952     ;DATOS A IMPRIMIR EN ESAS POSICIONES
CONTROL EQU   51954
CONVID  EQU   51956
VISHUE  EQU   51958     ;VARIABLE PARA SABER SI HAS VISTO EL HUEVO DE PASCUA

        INCLUDE  "IMPMENU.ASM"
        INCLUDE  "IMP.ASM"
        INCLUDE  "BOSPRI.ASM"
        INCLUDE  "CALLENE.ASM"
        INCLUDE  "MAPEADOR.ASM"
        INCLUDE  "BORRAPAN.ASM"
        INCLUDE  "OBJETOS.ASM"
        INCLUDE  "JOBOJE2.ASM"
        INCLUDE  "LETRAS.ASM"
        INCLUDE  "PISTAS.ASM"
        INCLUDE  "BORRTEX.ASM"
        INCLUDE  "RUTENE.ASM"
        INCLUDE  "FINAL.ASM"
        INCLUDE  "BORRPACO.ASM"
        INCLUDE  "CONTROLINTERRUP.ASM"
        INCLUDE  "SONIDOMU.ASM"
        INCLUDE  "RUPASOS.ASM"
        INCLUDE  "CREDITOS.ASM"
        INCLUDE  "BORVID.ASM"
        INCLUDE  "JULIAN.ASM"
        INCLUDE  "MARCOYREJ.ASM"
        INCLUDE  "MARCABAJOJINJ.ASM"
        INCLUDE  "PLANTILLAFINAL.ASM"
        INCLUDE  "WYZPLAYER.ASM"

        INCLUDE  "TABENE.ASM"
        INCLUDE  "LOGOCEZGS.ASM"
        INCLUDE  "ISRJJ.ASM"
        INCLUDE  "ENEMETAB.ASM"
        INCLUDE  "TABDATAS.ASM"
        INCLUDE  "TABPANT.ASM"
        INCLUDE  "TABINTERR.ASM"
