;###############################
; RUTINA DE GESTION DE OBJETOS
;###############################
; HL TIENE EL VALOR EN EL ARCHIVO DE ATRIBUTOS DE LA POSICION INMEDIATA SUPERIOR
; A= AL CONTENIDO DE HL

RU_OBJE PUSH AF
        PUSH BC
        PUSH DE
        PUSH HL
        LD A,(OBJE)
        CP 4         ; NO LLEVA OBJETOS
        JR Z,MONE_1
        CP 0         ; PORTA LA MONEDA
        JR Z,TIJE_1
        CP 1         ; PORTA LAS TIJERAS
        JR Z,LLAVE_1
        CP 2         ; PORTA LA LLAVE
        JR Z,GATO_1
        JP FINRUOB   ; A DONDE VAMOS ? YA LOS LLEVAMOS TODOS
MONE_1  XOR A        ; ESTA PARTE SIRVA DE OFFSET PARA
        LD (OBJE),A  ; LA TABLA DE DIRECCIONES EN EL MARCADOR
        JR CO_RUOB   ; DE LOS OBJETOS QUE LLEVAREMOS.
TIJE_1  LD A,1
        LD (OBJE),A
        JR CO_RUOB
LLAVE_1 LD A,2
        LD (OBJE),A
        JR CO_RUOB
GATO_1  LD A,3
        LD (OBJE),A
CO_RUOB LD HL,T_OB_DI
        ADD A,A
        ADD A,L
        LD L,A       ;HL APUNTA A LA NUEVA DIR.
        LD A,(HL)
        LD (DIRENM),A
        INC L
        LD A,(HL)
        LD (DIRENM+1),A  ;TRASPASADO A DIRENM EL VALOR DE HL
	LD A,(FILA)  ;LA FILA AL LLEGAR AQUI LLEVA UN DECREMENTO YA!
	DEC A
	LD B,A
	LD A,(COLU)
	LD C,A
	CALL IM_CHAR    ; EN HL TENEMOS LA NUEVA DIR.
        PUSH HL         ;PARA 'VACIAR' LA POS.DEL OBJETO
        LD B,2
OBS_SC  PUSH HL
        PUSH BC
        LD B,8
OB_S_1  PUSH BC
        PUSH HL
	LD A,(HL)	;LEO EL PRIMER SCAN DEL PRIMER BYTE
	LD D,A		;GUARDAR EN D PARA TRASPASARLO
	INC L		;PASAMOS AL BYTE DE AL LADO
	LD A,(HL)
	LD E,A		;LO GUARDAMOS
	LD HL,(DIRENM)  ;Traspaso de los datos a su posicion en el marcador
        LD A,D
	LD (HL),A
	INC L
	LD A,E
	LD (HL),A
        LD A,(DIRENM+1)
        ADD A,1
        LD (DIRENM+1),A  ;GUARDO LA DIR. EN SU VARIABLE
        POP HL
        POP BC
        INC H
        DJNZ OB_S_1
        LD A,#50        ;SIGUIENTE FILA EN MARCADOR
        LD (DIRENM+1),A
        LD A,(DIRENM)
        ADD A,#20
        LD (DIRENM),A   ;FIN SIG.FILA EN MARCADOR
        POP BC
        POP HL
        LD A,#20
        ADD A,L
        LD L,A
        DJNZ OBS_SC
        POP HL     ;SACO LA POS.INICIAL PARA VACIAR EL OBJETO.
        LD A,(FILA)
        DEC A
        LD (FIL_DAT),A
        LD A,(COLU)
        LD (COL_DAT),A
        CALL IM_ATD_
        XOR A
        LD (HL),A
        INC L
        LD (HL),A
        LD DE,31
        ADC HL,DE
        LD (HL),A
        INC L
        LD (HL),A   ;FIN COLOCAR ATRIBUTOS EN POS.OBJETO
;SONIDO RECOGER OBJETOS
	XOR A
        LD C,0
L_SON1  OUT (254),A
        LD B,C   ;CON 0 QUEDA BIEN PARA COGER OBJETOS
WATI    DJNZ WATI
        XOR 16
        DEC C
        JR NZ,L_SON1
;FIN SONIDO RECOGER OBJETOS
; 'VACIAR' LA POSIC. EN TABPANT DE LOS OBJETOS SEGUN LA PANTALLA
        LD A,(PANTA)
        CP 20
        JR Z,P0EN20
        CP 9
        JR Z,P0EN9
        CP 17
        JR Z,P0EN17
        JR P0EN29
P0EN20  XOR A
        LD (60639),A
        JR FINRUOB
P0EN9   XOR A
        LD (59246),A
        JR FINRUOB
P0EN17  XOR A
        LD (60078),A
        JR FINRUOB
P0EN29  XOR A
        LD (62118),A
;FIN DE VACIAR LAS POSICIONES ABSOLUTAS DE LOS OBJETOS EN SU PANTALLA
FINRUOB CALL PISTAS           ;QUITAR LA LLAMADA A LAS PISTASA, SOLO ES DE PRUEBA...POR SI ESTA MAL
        LD A,1                ;VARIABLE A 1 PARA PODER PITAR AL PASAR A PANTALLA ESCONDIDA.
        LD (NOOBJE),A
        POP HL
        POP DE
        POP BC
        POP AF
        RET             ;DEVUELVO EL CONTROL
T_OB_DI DEFB #8B,#50
        DEFB #8D,#50
        DEFB #8F,#50
        DEFB #91,#50

;VALORES EN COLUMNA Y FILA DENTRO DEL MARCADOR
; MONEDA EN         11,20            508B
; TIJERAS           13,20            508D
; LLAVE             15,20            508F
; GATITO            17,20            5091
