;####################################
;   rutina de impresion de pistas.
;####################################



PISTAS  PUSH AF
        PUSH BC
        PUSH DE
        PUSH HL
        LD A,(FILA)                  ;PARA VER DE QUITAR EL PROBLEMA
        INC A                        ;CON LOS DATOS QUE SE QUEDAN
        LD (FILA),A                  ;AL RETORNAR DE LOS TEXTOS.
        LD A,(OBJE)                  ; POR EJEMPLO
        CP 0
        JR Z,PIMO
        CP 1
        JR Z,PITI
        CP 2
        JR Z,PILL
        CP 3
        JR Z,PIGA
        JP FINPIS
PIMO    LD A,19                      ;DATOS PARA LLEVAR AL BORRAR LA PANTALLA
        LD (PANTA),A
        LD A,1
        LD (SENPRO),A
        LD (FLAGPA),A
        CALL RUBORTEX                ;BORRO LA PANTALLA PARA IMPRIMIR EL MENSAJE
        LD DE,TEXTO
        JR SIPI

PITI    LD A,10                      ;DATOS PARA LLEVAR AL BORRAR LA PANTALLA
        LD (PANTA),A
        LD A,3
        LD (SENPRO),A
        LD A,1
        LD (FLAGPA),A
        LD A,2
        LD (FILA),A
        LD A,(TXT)                   ;TRASPASO A DE EL VALOR DE TXT = POSIC.GUARD.DE LOS TEXTOS
        LD E,A
        LD A,(TXT+1)
        LD D,A
        CALL RUBORTEX                   ;BORRO LA PANTALLA PARA IMPRIMIR EL MENSAJE
        JR SIPI

PILL    LD A,16                      ;DATOS PARA LLEVAR AL BORRAR LA PANTALLA
        LD (PANTA),A
        LD A,1
        LD (SENPRO),A
        LD (FLAGPA),A
        LD A,8
        LD (FILA),A
        LD A,(TXT)                   ;TRASPASO A DE EL VALOR DE TXT = POSIC.GUARD.DE LOS TEXTOS
        LD E,A
        LD A,(TXT+1)
        LD D,A
        CALL RUBORTEX                   ;BORRO LA PANTALLA PARA IMPRIMIR EL MENSAJE
        JR SIPI

PIGA    LD A,30                     ;DATOS PARA LLEVAR AL BORRAR LA PANTALLA
        LD (PANTA),A
        LD A,3
        LD (SENPRO),A
        LD A,1
        LD (FLAGPA),A
        LD A,6
        LD (FILA),A
        LD A,(TXT)                   ;TRASPASO A DE EL VALOR DE TXT = POSIC.GUARD.DE LOS TEXTOS
        LD E,A
        LD A,(TXT+1)
        LD D,A
        CALL RUBORTEX                   ;BORRO LA PANTALLA PARA IMPRIMIR EL MENSAJE

SIPI
        LD B,10          ; LINEAS A IMPRIMIR
        LD A,4          ; FILA DONDE EMPIEZA A IMPRIMIR
PIBUC   PUSH BC
	PUSH AF
        ld c,0
        LD B,17         ;contador de los caracteres a imprimir
        LD A,22         ;POSICION AT
        RST 16
        POP AF          ;VALOR DE POS PARA LA FILA
        PUSH AF
        RST 16
        LD A,2         ;COLUMNA 2
        RST 16

PILAZO  LD A,(DE)       ;cargo el primer caracter
        RST 16		; chimpun
        INC DE		;incremento la posi pa cargar el siguiente
        DJNZ PILAZO     ;salta si no has llegao al final
	POP AF
	INC A
        POP BC
        DJNZ PIBUC
        LD A,E       ;TRASPASO A LA VARIABLE TXT LA POSICION
        LD (TXT),A      ;ACTUAL DE LOS TEXTOS
        LD A,D
        LD (TXT+1),A

           LD A,6                   ;COLOR AMARILLO PARA TEXTO
           LD HL,#5880
           LD B,5
BPISTEX2   PUSH BC
           LD B,24
BPISTEX    LD (HL),A
           INC L
           DJNZ BPISTEX
           POP BC
           LD DE,8
           ADC HL,DE
           DJNZ BPISTEX2

           LD A,5                   ;COLOR Azul PARA TEXTO ingles
           LD HL,#5920
           LD B,5
BPISTEX3   PUSH BC
           LD B,24
BPISTEX31  LD (HL),A
           INC L
           DJNZ BPISTEX31
           POP BC
           LD DE,8
           ADC HL,DE
           DJNZ BPISTEX3
;DELAY
        LD B,255
        LD C,255
PA2     DEC C
        JR NZ,PA2
        DJNZ PA2
;FIN DELAY
GUAI    XOR A
        IN A,(#FE)
        CPL
        AND #1F
        JR Z,GUAI

        CALL RUBOR    ; RUBOR RUTINA DE BORRADO DE PANTALLA
        CALL MAPPING
        CALL BUPAIM
        LD A,(POS_PRO) ;TRASPASO ULTIMO FRAME CONOCIDO DEL PROTA AL PASAR AHORA DE PANTALLA.
        LD E,A
        LD A,(POS_PRO+1)
        LD D,A
        CALL MOV
        LD A,(FILA)
        DEC A
        LD (FILA),A


FINPIS  POP HL
        POP DE
        POP BC
        POP AF

        RET
 TEXTO  DEFB "'..si la aventura"
        DEFB "quieres continuar"
        DEFB "pide un deseo y  "
        DEFB "se te concedera.'"
        DEFB "                 "
        DEFB "' if ye adventure"
        DEFB "to continue thou "
        DEFB "want,make a wish "
        DEFB "and it will be   "
        DEFB "granted....'     "

        DEFB "'si un obstaculo "
        DEFB "quieres salvar,  "
        DEFB "utilizalas y lo  "
        DEFB "conseguiras....' "
        DEFB "                 "
        DEFB "...if an obstacle"
        DEFB "to bypass thou   "
        DEFB "want, use'em and "
        DEFB "thou'll make it.'"
        DEFB "                 "

        DEFB "'abre la cancela "
        DEFB "oculta, mas alla "
        DEFB "de la equis de   "
        DEFB "piedra o aspa...'"
        DEFB "                 "
        DEFB "'open the fence, "
        DEFB "hideth beyond the"
        DEFB "stone cross.....'"
        DEFB "                 "
        DEFB "                 "


        DEFB "'...los acertijos"
        DEFB "donde mejor se   "
        DEFB "aclaran es donde "
        DEFB "se escriben.....'"
        DEFB "                 "
        DEFB "'riddles art best"
        DEFB "solved where they"
        DEFB "art written.....'"
        DEFB "                 "
        DEFB "                 "
