;Datos para volcar los enemigos a segn que pantalla.
;Los datos son:

;Npantalla,Bytene,BBajo1,BAlto1,DispHV,Lim1-Ancol,Lim2-Anfil,Col,Fil,Bbajo2,Balto2,Dirxy

;N pantalla= obvio
;Bytene= que enemigos se mueven en la pantalla?
;BBajo= byte bajo de la direccin a la que apunta el primer frame del enemigo a imprimir
;BAlto= byte alto """
;DispHV= sentido del sprite al moverse 1-der,2-izq,3-arr,4-aba
;Lim1/Ancol= limite izq. o arriba o en caso de sprite 5 Ancol = Anterior columna impresa
;lim2/Anfil= limite der. o abajo """" sprite 5 Anfil= fila...
;Col= obvio
;Fil= obvio
;Frame/Vdtspx  Frame a imprimir en sprite 5 para saber si ha tropezado en las 4 direcciones
;Dirxy/Varspx  Dirxy Guarda el valor de la posic. anterior del sprite. Varspx intercambia entre col y fil
;ojooooooooooooooo dirxy utilizar dos posiciones mientras que varspx para el enem5 solo una. ver esto
;Varios de los datos estarn a 0 debido a su "valor" concreto en la rutina lo que hace que no tenga
;datos al entrar.

;BYTENE   tiene valores de 0 a 5 segn
; 0000 0000    a    0001 1111
; 0 = 0
; 1 = enem1                    00000001
; 3 = enem1 y enem2            00000011
; 4 = enem3                    00000100
; 5 = enem1 y enem3            00000101
; 7 = enem1,enem2 y enem3      00000111
; 12= enem3 y enem4            00001100
; 13= enem1,enem3 y enem4      00001101
; 15= enem1,enem2,enem3 y ene4 00001111
; 16= enem5                    00010000
; 17= enem1 y enem5            00010001
; 19= enem1,enem2 y enem5      00010011
; 20= enem3 y enem5            00010100
; 21= enem1,enem3 y enem5      00010101
; 23= enem1,enem2,enem3 y ene5 00010111

;Direcciones de los enemigos
;ARANITA		EQU 0D0A0H     #A0,#D0       160,208
;BILO_DE		EQU 0CBA0H     #A0,#CB       160,203
;BILO_IZ		EQU 0CB20H     #20,#CB       32,203
;BOLA		        EQU 0D120H     #20,#D1       32,209
;CALADE		        EQU 0CD20H     #20,#CD       32,205
;CALAIZ		        EQU 0CDA0H     #A0,#CD       160,205
;CAR_BA		        EQU 0CFA0H     #A0,#CF       160,207
;CAR_SU		        EQU 0CF20H     #20,#CF       32,207
;CULEDE		        EQU 0CE20H     #20,#CE       32,206
;CULEIZ		        EQU 0CEA0H     #A0,#CE       160,206
;FUEGO		        EQU 0D020H     #20,#D0       32,208
;GORR_DE		EQU 0CC20H     #20,#CC       32,204
;GORR_IZ		EQU 0CCA0H     #A0,#CC       160,204

;Npantalla,Bytene,
;BBajo1,BAlto1,DispHV,Lim1-Ancol,Lim2-Anfil,Col,Fil,Bbajo2-Vdtspx,Balto2,Dirxy-Varspx
;En total son 54 bytes por pantalla. El enemigo 5 usa 8 bytes, los otros 11bytes cada uno.

             ORG 24991               ;ORIGINALMENTE 50010
TA_BENE
;Pantalla 0
             DEFB 0,5
             DEFB 160,203,2,11,20,20,14,32,203,#D4,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,208,4, 2, 6,20, 2,32,208,#54,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 1
             DEFB 1,3
             DEFB 32,204,1,6,20,6,2,160,204,#46,#40
             DEFB 160,203,2, 10, 16,16, 10,32,203,#50,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 2
             DEFB 2,5
             DEFB 32,204,2,4,9,9,13,160,204,#A9,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,208,4,4,13,20,6,32,208,#D4,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 3
             DEFB 3,3
             DEFB 32,204,2,2,9,9,4,160,204,#89,#40
             DEFB 160,203,1,13,20,13,4,32,203,#8F,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 32,209,#4C,#48,12,10,0,0
;Pantalla 4
             DEFB 4,7
             DEFB 160,203,2,14,20,20,4,32,203,#94,#40
             DEFB 32,204,1,8,12,8,13,160,204,#A8,#48
             DEFB 32,207,4,6,11,6,6,160,207,#C6,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 5
             DEFB 5,5
             DEFB 160,203,1,7,17,7,14,32,203,#C7,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,207,4,5,11,18,5,160,207,#B2,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 32,209,#0A,#48,10,8,0,0
;Pantalla 6
             DEFB 6,5
             DEFB 32,204,1,12,18,12,10,160,204,#4C,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,208,4,10,14,20,10,32,208,#54,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 32,209,#42,#48,2,10,0,0
;Pantalla 7
             DEFB 7,15
             DEFB 160,203,1,2,18,4,2,32,203,#44,#40
             DEFB 32,204,2,4,18,18,12,160,204,#92,#48
             DEFB 32,208,4,6,8,11,6,32,208,#CB,#40
             DEFB 32,207,3,6,12,2,12,160,207,#94,#48
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 8
             DEFB 8,5
             DEFB 32,204,2,10,18,20,14,160,204,#D4,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,207,4,3,12,18,5,160,207,#B2,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 9
             DEFB 9,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 10
             DEFB 10,1          ;16 X 20 SI PUSIERAMOS EL OTRO
             DEFB 160,208,2,0,8,8,4,160,208,#88,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 11
             DEFB 11,7
             DEFB 32,205,2,12,20,18,2,160,205,#52,#40
             DEFB 32,206,1,14,22,14,12,160,206,#8E,#48
             DEFB 32,207,4,2,8,8,2,160,207,#48,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 12
             DEFB 12,1
             DEFB 32,206,2,0,8,8,12,160,206,#88,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 160,208,#2B,#48,11,9,0,0
;Pantalla 13
             DEFB 13,4
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,208,4,8,14,20,8,32,208,#14,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 14
             DEFB 14,3
             DEFB 32,204,2,2,10,10,10,160,204,#4A,#48
             DEFB 32,206,1,11,20,11,12,160,206,#8E,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 15
             DEFB 15,13
             DEFB 32,205,1,3,9,4,5,160,205,#A4,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,208,4,3,9,13,3,32,208,#6D,#40
             DEFB 32,207,4,6,12,20,6,160,207,#D4,#40
;             DEFB 32,207,3,6,12,20,12,160,207,#94,#48

;             DEFB 0,0,0,0,0,0,0,0

;Pantalla 16
             DEFB 16,5
             DEFB 160,208,1,12,22,12,10,160,208,#D2,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,209,3,7,13,7,13,32,209,#8B,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 17
             DEFB 17,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 18
             DEFB 18,12
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,209,4,4,11,14,4,32,209,#8E,#40
             DEFB 32,208,4,4,8,20,4,32,208,#94,#40
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 19
             DEFB 19,5
             DEFB 160,203,1,2,20,2,14,32,203,#C2,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,207,4,4,8,20,4,160,207,#94,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 32,209,#C2,#40,2,6,0,0
;Pantalla 20
             DEFB 20,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 21
             DEFB 21,3
             DEFB 32,209,1,4,20,4,6,32,209,#E4,#40
             DEFB 32,204,2,6,18,18,12,160,204,#92,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 22
             DEFB 22,15
             DEFB 160,203,1,8,15,8,6,32,203,#C8,#40
             DEFB 32,204,2,2,20,20,14,160,204,#D4,#48
             DEFB 32,208,4,4,12,2,8,32,208,#82,#40
             DEFB 32,207,3,4,12,20,12,160,207,#94,#48
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 23
             DEFB 23,1
             DEFB 32,204,1,9,16,9,12,160,204,#89,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 32,209,#92,#40,18,4,0,0
;Pantalla 24
             DEFB 24,7
             DEFB 160,203,1,4,14,4,2,32,203,#44,#40
             DEFB 32,209,2,2,16,16,14,32,209,#D2,#48
             DEFB 32,207,4,6,12,12,6,160,207,#CC,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 25
             DEFB 25,5
             DEFB 32,204,1,6,13,6,4,160,204,#86,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,209,4,2,12,20,2,32,209,#54,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 26
             DEFB 26,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 160,208,#88,#48,8,12,0,0
;Pantalla 27
             DEFB 27,1
             DEFB 32,206,1,13,22,13,7,160,206,#ED,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 28
             DEFB 28,12
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,209,4,6,14,5,6,32,209,#C5,#40
             DEFB 160,208,3,6,14,15,14,160,208,#CF,#48
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 29
             DEFB 29,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 30
             DEFB 30,3
             DEFB 32,205,1,10,17,10,11,160,205,#6A,#48
             DEFB 32,204,1,2,10,2,8,160,204,#02,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 31
             DEFB 31,3
             DEFB 32,205,1,3,12,3,12,160,205,#83,#48
             DEFB 32,206,2,5,12,12,8,160,206,#0C,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 32
             DEFB 32,5
             DEFB 160,203,1,10,16,10,5,32,203,#AA,#40
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 32,207,3,10,14,3,14,160,207,#C3,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 33
             DEFB 33,1
             DEFB 32,205,1,2,18,2,14,160,205,#C2,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 34
             DEFB 34,7
             DEFB 32,205,1,12,20,12,4,160,205,#8C,#40
             DEFB 32,206,2,2,15,15,14,160,206,#CF,#48
             DEFB 32,208,4,10,14,17,10,32,208,#51,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;Pantalla 35
             DEFB 35,7
             DEFB 32,205,2,10,16,16,8,160,205,#10,#48
             DEFB 32,206,1,8,16,8,14,160,206,#C8,#48
             DEFB 160,208,4,10,14,4,10,160,208,#44,#48
             DEFB 0,0,0,0,0,0,0,0,0,0,0
;             DEFB 0,0,0,0,0,0,0,0
;             DEFB 160,208,#88,#40,8,4,0,0
